open Operators
open Builtin_defs

let len = 1024;;

let run_process s =
  let ic = Unix.open_process_in s in
  let b = Buffer.create (1024*10) in
  let buf = String.create len in
  let rec aux () =
    let i = input ic buf 0 len in
    if i = 0 then () else (Buffer.add_string b (String.sub buf 0 i); aux ())
  in
  aux ();
  let s = Value.string_latin1 (Buffer.contents b) in
  s, Unix.close_process_in ic



let () = register_fun "system" string_latin1 string_latin1
  (fun v ->
     Location.protect_op "system";
     match run_process (Value.get_string_latin1 v) with
       | s,Unix.WEXITED n ->
	   if (n = 0) then s
	   else
	     Value.raise' 
	       (Value.tagged_tuple "exited" [ Value.ocaml2cduce_int n; s ])
       | s,Unix.WSTOPPED n ->
	   Value.raise' 
	     (Value.tagged_tuple "stopped" [ Value.ocaml2cduce_int n; s ])
       | s,Unix.WSIGNALED n ->
	   Value.raise' 
	     (Value.tagged_tuple "signaled" [ Value.ocaml2cduce_int n; s ])
  )
  
let () = register_fun "exit" byte_int Types.empty
  (fun v -> Location.protect_op "exit"; exit (Value.cduce2ocaml_int v))
