open Printf
open Parser  


type line_buffer = 
    { mutable buffer : string ;
      mutable length : int;
      mutable abs_pos: int ;
      maxlength: int;
    }



(* this function fills the line buffer printing 
the prompt ?> at the first line and returning
the number of characters in the line '\n' included*)

let first_line = ref true
let got_eof = ref false

let refill_buf buffer len =
  if !got_eof then (got_eof := false; 0) else begin
    let prompt =
      if !first_line then "?> "
      else "   "
    in
    output_string stdout prompt; flush stdout;
    first_line := false;
    let i = ref 0 in
    try
      while true do
        if !i >= len then raise Exit;
        let c = input_char stdin in
        buffer.[!i] <- c;
        incr i;
        if c = '\n' then raise Exit;
      done;
      !i
    with
    | Exit -> !i
  end


(* The function scan takes a linebuffer buffer
   and returns a function (from the  current stream count
   to a char option) that is used to create the Stream
*)

let rec scan line_buf count =
   let element = count-(line_buf.abs_pos) in
   if element < line_buf.length then        (* send to stream the character *)
     Some  line_buf.buffer.[element] 
   else (                                   (* read another line*)
     line_buf.abs_pos <- (line_buf.abs_pos) + line_buf.length;
     line_buf.length  <- (refill_buf line_buf.buffer line_buf.maxlength)-1;
     scan line_buf count)




(* JUST FOR TESTING  *) 
let loop = 
  fprintf stdout "                CDuce version 0.2a1\n\n";
  let line_buffer =
   { buffer =  "                                                             ";
     length =  0;
     abs_pos = 0;
     maxlength = 60;
   } in
  let input = Stream.from (scan line_buffer) in
  Sys.catch_break true;  
  while true do
    try
      first_line := true;
      let semicolon = ref 0 in
      while !semicolon < 2 do
        try
          let c = Stream.next input in
            if c = ';' then incr semicolon
            else semicolon := 0
        with
        | End_of_file ->
           if !first_line then exit 0
      done
    with 
    | End_of_file -> exit 0
    | Sys.Break -> fprintf stdout "Chang d'avis?\n"
  done












       
(* JUST FOR TESTING 2  
let loop x = 
  fprintf stdout "                CDuce version 0.2a1\n\n";
  let line_buffer =
   { buffer =  "                                                             ";
     length =  0;
     abs_pos = 0;
     maxlength = 60;
   } in
  let input = Stream.from (scan line_buffer) in
  Sys.catch_break true;
  while true do
     first_line := true;
     Parser.prog input 
  done
  

*)

(*   THE REAL LOOP 
let loop ppf =
  fprintf ppf "                CDuce version 0.2a1";
(*  
  initialize_toplevel_env ();
*)
  let line_buffer =
   { buffer =  ref "                                                             ";
     lenth = ref 0;
     abs_pos = ref 0;
     maxlength = 60;
   }
  let input = Stream.from scan line_buffer
  Sys.catch_break true;
  while true do
    try
     empty_buf line_buffer;
     first_line := true;
     try Parser.prog input 
     with
      | Stdpp.Exc_located (loc, e) -> raise (Location (loc, e))
(*       
     while not lexed ";;" 
        Parse and catch ";;" to end inner loop
     update_toplevel_env(????)
     print type line
     print execution line
*)
    with
    | End_of_file -> exit 0
    | Sys.Break -> fprintf ppf "Interrupted.@."
    | PPerror -> ()
    | x -> Errors.report_error ppf x
  done
*)


